plugins {
    `java-gradle-plugin`
    kotlin("jvm")
}

repositories {
    mavenCentral()
}

dependencies {
    implementation("org.jetbrains.kotlin:kotlin-reflect:_")

    implementation(Square.okHttp3.okHttp)
    implementation("com.jsoniter:jsoniter:_")
    implementation(Square.kotlinPoet)
    implementation("com.google.guava:guava:_")
}

tasks {
    compileKotlin {
        kotlinOptions.freeCompilerArgs += "-Xopt-in=kotlin.time.ExperimentalTime"
    }
}

gradlePlugin {
    plugins {
        create("minecraft-data-sources") {
            id = "minecraft-data-sources"
            implementationClass = "space.uranos.mdsp.MinecraftDataSourcesPlugin"
        }
    }
}
