package space.uranos.testplugin.anvil

import space.uranos.world.Chunk
import space.uranos.world.Voxel
import space.uranos.world.VoxelLocation
import space.uranos.world.block.Block

class AnvilVoxel(
    override val location: VoxelLocation,
    override val world: AnvilWorld
) : Voxel() {
    private val chunkX: Int
    private val sectionY: Int = location.y.toInt() % Chunk.SECTION_HEIGHT
    private val chunkZ: Int

    init {
        val (x, z) = chunk.key.translateWorldToChunk(location.x, location.z)
        chunkX = x
        chunkZ = z
    }

    private val sectionIndex = location.y.toInt() / Chunk.SECTION_HEIGHT
    private val index = sectionY * Chunk.AREA + chunkZ * Chunk.LENGTH + chunkX

    override var block: Block
        get() = (chunk as AnvilChunk).sections[sectionIndex].blocks[index]
        set(value) {
            (chunk as AnvilChunk).sections[sectionIndex].blocks[index] = value
        }
}
