plugins {
    kotlin("jvm")
    kotlin("kapt")
}

group = rootProject.group
version = rootProject.version

repositories {
    mavenCentral()
    jcenter()
}


dependencies {
    // Kotlin
    api("org.jetbrains.kotlin:kotlin-reflect:_")
    api(KotlinX.coroutines.core)

    // JSON
    kapt(Square.moshi.kotlinCodegen)
    api(Square.moshi)

    // Netty
    api("io.netty:netty-buffer:_")

    // Other
    api("com.google.guava:guava:_")

    // Testing
    testImplementation(Testing.Strikt.core)
    testImplementation(Testing.junit.api)
    testRuntimeOnly(Testing.junit.engine)
}

kotlin {
    sourceSets["main"].kotlin.srcDir("src/main/generatedKotlin")
}

tasks {
    test {
        useJUnitPlatform()
    }
}
