package space.uranos.chat

/**
 * You should use [ChatComponent][space.uranos.chat.ChatComponent] whenever it's possible, but sometimes these codes
 * are required, for example in the name of a player in a server list sample.
 */
enum class LegacyFormattingCode(private val char: Char) {
    BLACK('0'),
    DARK_BLUE('1'),
    DARK_GREEN('2'),
    DARK_AQUA('3'),
    DARK_RED('4'),
    DARK_PURPLE('5'),
    GOLD('6'),
    GRAY('7'),
    DARK_GRAY('8'),
    BLUE('9'),
    GREEN('a'),
    AQUA('b'),
    RED('c'),
    LIGHT_PURPLE('d'),
    YELLOW('e'),
    WHITE('f'),
    OBFUSCATED('k'),
    BOLD('l'),
    STRIKETHROUGH('m'),
    UNDERLINE('n'),
    ITALIC('o'),
    RESET('r');

    override fun toString(): String = "§$char"
    operator fun plus(value: LegacyFormattingCode) = toString() + value.toString()
    operator fun plus(value: String) = toString() + value
}
