package space.uranos.entity

import space.uranos.CardinalDirection
import space.uranos.PaintingMotive
import space.uranos.world.VoxelLocation
import kotlin.math.max

interface PaintingEntity : Entity {
    val topLeftLocation: VoxelLocation
    val facing: CardinalDirection
    val motive: PaintingMotive

    companion object Type : AreaEffectCloudEntityType()
}

fun PaintingEntity.calculateCenterLocation() = topLeftLocation.copy(
    x = max(0, motive.width / 2) + topLeftLocation.x,
    z = motive.height / 2 + topLeftLocation.z
)
