package space.uranos.entity

import space.uranos.player.Player
import space.uranos.world.World

interface PlayerEntity : LivingEntity, HasMovableHead {
    val player: Player

    companion object Type : PlayerEntityType()
}

/**
 * As player entities are always in a world, you can use this property instead of [getWorldOrFail].
 */
val PlayerEntity.safeWorld: World get() = getWorldOrFail()
