package space.uranos.event

interface EventHandlerPositionManager {
    fun positionOf(eventHandlerPosition: EventHandlerPosition): Int
    fun positionOfOrNull(eventHandlerPosition: EventHandlerPosition): Int?

    /**
     * Shorthand for `insertBefore(EventHandlerPosition.LAST, new)`.
     */
    fun insert(vararg positions: EventHandlerPosition)

    /**
     * Inserts [positions] before [existing].
     *
     * @throws IllegalArgumentException When [existing] is [EventHandlerPosition.FIRST]
     */
    fun insertBefore(existing: EventHandlerPosition, vararg positions: EventHandlerPosition)

    /**
     * Inserts [positions] after [existing].
     *
     * @throws IllegalArgumentException When [existing] is [EventHandlerPosition.LAST]
     */
    fun insertAfter(existing: EventHandlerPosition, vararg positions: EventHandlerPosition)
}
