package space.uranos.net.event

import space.uranos.event.Cancellable
import space.uranos.net.Session
import space.uranos.player.Player
import space.uranos.world.VoxelLocation

/**
 * Emitted when a [Player] instance will be initialized.
 *
 * If the event is cancelled, the session is disconnected.
 */
class PlayerInitializationEvent(override val target: Session, val settings: Player.Settings) : SessionEvent(), Cancellable {
    override var cancelled = false
    var compassTarget: VoxelLocation = VoxelLocation.of(0, 0, 0)
}
