package space.uranos.net.packet

sealed class Packet {
    override fun toString(): String = this::class.java.simpleName + "(no data)"
}

abstract class IncomingPacket : Packet()

interface Mergeable {
    /**
     * Merges this packet with [otherPacket] or returns null if the packets cannot be merged.
     *
     * If there are conflicts, the values from this packet should take precedence.
     */
    fun mergeWith(otherPacket: OutgoingPacket): OutgoingPacket?
}

abstract class OutgoingPacket : Packet()
