package space.uranos.util

/**
 * If [count] is 1, it returns [singular], else [plural].
 *
 * [plural] defaults to [singular] + 's'.
 */
fun pluralize(singular: String, count: Int, plural: String = singular + "s") =
    if (count == 1) singular else plural

/**
 * Same as [pluralize], but prepends `count + " "`.
 */
fun pluralizeWithCount(singular: String, count: Int, plural: String = singular + "s") =
    "$count ${pluralize(singular, count, plural)}"
