package space.uranos.util.numbers

fun Int.clamp(range: IntRange) = maxOf(minOf(range.first, range.last), minOf(maxOf(range.first, range.last), this))

fun validateParameterIsInRange(name: String, range: IntRange, actualValue: Int) {
    if (!range.contains(actualValue)) throw IllegalArgumentException("$name must be in $range")
}

fun validateParameterIsInRange(name: String, range: IntRange, actualValue: Float) {
    if (range.first > actualValue || range.last < actualValue) throw IllegalArgumentException("$name must be in $range")
}
