package space.uranos.util

import org.junit.jupiter.api.Test
import space.uranos.util.numbers.floorMod
import strikt.api.expectThat
import strikt.api.expectThrows
import strikt.assertions.isEqualTo
import strikt.assertions.isTrue

class FloatFloorModTest {
    @Test
    fun `throws an error when divisor is 0`() {
        expectThrows<ArithmeticException> { floorMod(0f, 0f) }
        expectThrows<ArithmeticException> { floorMod(20f, 0f) }
        expectThrows<ArithmeticException> { floorMod(-20f, 0f) }
    }

    @Test
    fun `returns correct results`() {
        expectThat(floorMod(0f, 1f) == 0f).isTrue()
        expectThat(floorMod(20f, 1f) == 0f).isTrue()
        expectThat(floorMod(-20f, 1f) == 0f).isTrue()

        expectThat(floorMod(110f, 100f)).isEqualTo(10f)
        expectThat(floorMod(-110f, 100f)).isEqualTo(90f)
        expectThat(floorMod(110f, -100f)).isEqualTo(-90f)
        expectThat(floorMod(-110f, -100f)).isEqualTo(-10f)
    }
}
