package space.uranos.util

import org.junit.jupiter.api.Test
import space.uranos.server.Server
import strikt.api.expectThat
import strikt.assertions.isEqualTo

class TicksTest {
    @Test
    fun `secondsToTicks correctly converts seconds to ticks`() {
        expectThat(secondsToTicks(0)).isEqualTo(0)
        expectThat(secondsToTicks(1)).isEqualTo(Server.TICKS_PER_SECOND.toLong())
        expectThat(secondsToTicks(5)).isEqualTo(5 * Server.TICKS_PER_SECOND.toLong())

        expectThat(secondsToTicks(0.0)).isEqualTo(0)
        expectThat(secondsToTicks(2.5)).isEqualTo((2.5 * Server.TICKS_PER_SECOND).toLong())
    }
}
