package space.uranos.nbt

class NBTBuilderContext(val nbt: NBT) {
    inline operator fun String.invoke(init: NBTBuilderContext.() -> Unit) = nbt.set(this, buildNBT(init))
    infix fun String.set(value: Byte) = nbt.set(this, value)
    infix fun String.set(value: Short) = nbt.set(this, value)
    infix fun String.set(value: Int) = nbt.set(this, value)
    infix fun String.set(value: Long) = nbt.set(this, value)
    infix fun String.set(value: Float) = nbt.set(this, value)
    infix fun String.set(value: Double) = nbt.set(this, value)
    infix fun String.set(value: ByteArray) = nbt.set(this, value)
    infix fun String.set(value: String) = nbt.set(this, value)
    infix fun String.set(value: Collection<*>) = nbt.set(this, value)
    infix fun String.set(value: NBT) = nbt.set(this, value)
    infix fun String.set(value: LongArray) = nbt.set(this, value)
    infix fun String.setAsByte(value: Boolean) = nbt.setAsByte(this, value)
}
