package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.net.MinecraftProtocolDataTypes.readVarInt
import space.uranos.net.packet.IncomingPacketCodec

object ClientRequestPacketCodec :
    IncomingPacketCodec<ClientRequestPacket>(0x04, ClientRequestPacket::class) {
    override fun decode(msg: ByteBuf): ClientRequestPacket = ClientRequestPacket(
        when (msg.readVarInt()) {
            0 -> ClientRequestPacket.Type.PERFORM_RESPAWN
            1 -> ClientRequestPacket.Type.STATS
            else -> throw Exception("Unknown client request type")
        }
    )
}
