package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.net.MinecraftProtocolDataTypes.writeVarInt
import space.uranos.net.packet.OutgoingPacketCodec

object EntityRelativeMoveWithOrientationPacketCodec :
    OutgoingPacketCodec<EntityRelativeMoveWithOrientationPacket>(0x28, EntityRelativeMoveWithOrientationPacket::class) {
    override fun EntityRelativeMoveWithOrientationPacket.encode(dst: ByteBuf) {
        dst.writeVarInt(entityID)
        dst.writeShort(deltaX.toInt())
        dst.writeShort(deltaY.toInt())
        dst.writeShort(deltaZ.toInt())
        dst.writeByte(yaw.toInt())
        dst.writeByte(pitch.toInt())
        dst.writeBoolean(onGround)
    }
}
