package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.net.MinecraftProtocolDataTypes.writeVarInt
import space.uranos.net.packet.OutgoingPacketCodec

object EntityTeleportPacketCodec :
    OutgoingPacketCodec<EntityTeleportPacket>(0x56, EntityTeleportPacket::class) {
    override fun EntityTeleportPacket.encode(dst: ByteBuf) {
        dst.writeVarInt(entityID)
        dst.writeDouble(x)
        dst.writeDouble(y)
        dst.writeDouble(z)
        dst.writeByte(yaw.toInt())
        dst.writeByte(pitch.toInt())
        dst.writeBoolean(onGround)
    }
}
