package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.entity.Position
import space.uranos.net.packet.IncomingPacketCodec
import space.uranos.util.numbers.floorMod

object IncomingPlayerPositionPacketCodec :
    IncomingPacketCodec<IncomingPlayerPositionPacket>(0x13, IncomingPlayerPositionPacket::class) {
    override fun decode(msg: ByteBuf): IncomingPlayerPositionPacket = IncomingPlayerPositionPacket(
        Position(
            msg.readDouble(),
            msg.readDouble(),
            msg.readDouble()
        ),
        floorMod(msg.readFloat(), 360f),
        msg.readFloat(),
        msg.readBoolean()
    )
}
