package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.net.MinecraftProtocolDataTypes.writeVarInt
import space.uranos.net.packet.OutgoingPacketCodec
import space.uranos.util.numbers.bitmask

object OutgoingPlayerPositionPacketCodec :
    OutgoingPacketCodec<OutgoingPlayerPositionPacket>(0x34, OutgoingPlayerPositionPacket::class) {
    override fun OutgoingPlayerPositionPacket.encode(dst: ByteBuf) {
        dst.writeDouble(x)
        dst.writeDouble(y)
        dst.writeDouble(z)
        dst.writeFloat(yaw)
        dst.writeFloat(pitch)
        dst.writeByte(bitmask(relativeX, relativeY, relativeZ, relativeYaw, relativeHeadPitch))
        dst.writeVarInt(0) // Teleport ID, I am not sure why this is needed
    }
}
