package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.Difficulty
import space.uranos.net.packet.OutgoingPacketCodec

object ServerDifficultyPacketCodec : OutgoingPacketCodec<ServerDifficultyPacket>(0x0D, ServerDifficultyPacket::class) {
    override fun ServerDifficultyPacket.encode(dst: ByteBuf) {
        dst.writeByte(
            when (difficultySettings.difficulty) {
                Difficulty.PEACEFUL -> 0
                Difficulty.EASY -> 1
                Difficulty.NORMAL -> 2
                Difficulty.HARD -> 3
            }
        )

        dst.writeBoolean(difficultySettings.locked)
    }
}
