package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.net.MinecraftProtocolDataTypes.writeUUID
import space.uranos.net.MinecraftProtocolDataTypes.writeVarInt
import space.uranos.net.packet.OutgoingPacketCodec
import space.uranos.util.numbers.mapToUByte

object SpawnLivingEntityPacketCodec : OutgoingPacketCodec<SpawnLivingEntityPacket>(0x02, SpawnLivingEntityPacket::class) {
    override fun SpawnLivingEntityPacket.encode(dst: ByteBuf) {
        dst.writeVarInt(entityID)
        dst.writeUUID(uuid)
        dst.writeVarInt(type.numericID)
        dst.writeDouble(position.x)
        dst.writeDouble(position.y)
        dst.writeDouble(position.z)
        dst.writeByte(yaw.mapToUByte(360f).toInt())
        dst.writeByte(pitch.mapToUByte(360f).toInt())

        // This is named "head pitch" on wiki.vg, but it is actually head yaw.
        dst.writeByte(headYaw.mapToUByte(360f).toInt())

        dst.writeShort((velocity.x * 8000).toInt().toShort().toInt())
        dst.writeShort((velocity.y * 8000).toInt().toShort().toInt())
        dst.writeShort((velocity.z * 8000).toInt().toShort().toInt())
    }
}
