package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.net.MinecraftProtocolDataTypes.writeUUID
import space.uranos.net.MinecraftProtocolDataTypes.writeVarInt
import space.uranos.net.packet.OutgoingPacketCodec

object SpawnObjectEntityPacketCodec : OutgoingPacketCodec<SpawnObjectEntityPacket>(0x00, SpawnObjectEntityPacket::class) {
    override fun SpawnObjectEntityPacket.encode(dst: ByteBuf) {
        dst.writeVarInt(entityID)
        dst.writeUUID(uuid)
        dst.writeVarInt(type)
        dst.writeDouble(x)
        dst.writeDouble(y)
        dst.writeDouble(z)
        dst.writeByte(pitch.toInt())
        dst.writeByte(yaw.toInt())
        dst.writeInt(data)
        dst.writeShort((velocity.x * 8000).toInt().toShort().toInt())
        dst.writeShort((velocity.y * 8000).toInt().toShort().toInt())
        dst.writeShort((velocity.z * 8000).toInt().toShort().toInt())
    }
}
