package space.uranos.net.packet.play

import io.netty.buffer.ByteBuf
import space.uranos.CardinalDirection
import space.uranos.net.MinecraftProtocolDataTypes.writeUUID
import space.uranos.net.MinecraftProtocolDataTypes.writeVarInt
import space.uranos.net.MinecraftProtocolDataTypes.writeVoxelLocation
import space.uranos.net.packet.OutgoingPacketCodec

object SpawnPaintingPacketCodec : OutgoingPacketCodec<SpawnPaintingPacket>(0x03, SpawnPaintingPacket::class) {
    override fun SpawnPaintingPacket.encode(dst: ByteBuf) {
        dst.writeVarInt(entityID)
        dst.writeUUID(uuid)
        dst.writeVarInt(motive.numericID)
        dst.writeVoxelLocation(centerLocation)
        dst.writeByte(when(direction) {
            CardinalDirection.NORTH -> 2
            CardinalDirection.SOUTH -> 0
            CardinalDirection.WEST -> 1
            CardinalDirection.EAST -> 3
        })
    }
}
