package space.uranos.net.packet.login

import space.uranos.net.packet.IncomingPacket

/**
 * Sent by the client to initialize the login process.
 *
 * @param username The username of the client. This is not validated (yet). Can only be 16 characters long.
 */
data class LoginStartPacket(val username: String) : IncomingPacket() {
    init {
        if (username.length > 16) throw IllegalArgumentException("username can only be 16 characters long")
    }
}
