package space.uranos.net.packet.login

import space.uranos.net.packet.OutgoingPacket
import java.util.UUID

/**
 * Sent by the server to indicate that the login process succeeded.
 * After this packet is sent, the [session's currentProtocol][space.uranos.net.Session.currentProtocol] will be switched to
 * `PLAY`.
 *
 * @param uuid The UUID of the player.
 * @param username The username of the player. Can only be 16 characters long.
 */
data class LoginSuccessPacket(val uuid: UUID, val username: String) : OutgoingPacket() {
    init {
        if (username.length > 16) throw IllegalArgumentException("username can only be 16 characters long")
    }
}
