package space.uranos.net.packet.play

import space.uranos.net.packet.OutgoingPacket

// Name on wiki.vg: Entity Position and Rotation
data class EntityRelativeMoveWithOrientationPacket(
    val entityID: Int,
    val deltaX: Short,
    val deltaY: Short,
    val deltaZ: Short,
    /**
     * Ignored for entities implementing [HasMovableHead][space.uranos.entity.HasMovableHead].
     *
     * [EntityHeadYawPacket][space.uranos.net.packet.play.EntityHeadYawPacket] must be used instead.
     */
    val yaw: UByte,
    val pitch: UByte,
    val onGround: Boolean
) : OutgoingPacket() {
    companion object {
        fun convertToDeltaShort(delta: Double): Short = (delta * 32 * 128).toInt().toShort()
    }
}
