package space.uranos.net.packet.play

import space.uranos.net.packet.OutgoingPacket
import kotlin.random.Random

// Name on wiki.vg: Player Position and Look (clientbound)
/**
 * Teleports the receiving player to the specified position.
 */
data class OutgoingPlayerPositionPacket(
    val x: Double,
    val y: Double,
    val z: Double,
    val yaw: Float,
    val pitch: Float,
    val relativeX: Boolean = false,
    val relativeY: Boolean = false,
    val relativeZ: Boolean = false,
    val relativeYaw: Boolean = false,
    val relativeHeadPitch: Boolean = false,
    val teleportID: Int = Random.nextInt()
) : OutgoingPacket()
