package space.uranos.net.packet.play

import space.uranos.net.packet.OutgoingPacket

/**
 * Tells the client some things about the player.
 *
 * @param invulnerable Whether the player is invulnerable.
 * @param flying Whether the player is currently flying.
 * @param canFly Whether the player is allowed to fly.
 * @param flyingSpeed The player's flying speed.
 * @param fieldOfView The player's field of view modifier.
 */
data class PlayerAbilitiesPacket(
    val invulnerable: Boolean,
    val flying: Boolean,
    val canFly: Boolean,
    val flyingSpeed: Float,
    val fieldOfView: Float
) : OutgoingPacket()
