package space.uranos.net.packet.play

import space.uranos.Vector
import space.uranos.entity.EntityType
import space.uranos.entity.Position
import space.uranos.net.packet.OutgoingPacket
import java.util.UUID

/**
 * Sent to spawn **living** entities.
 */
data class SpawnLivingEntityPacket(
    val entityID: Int,
    val uuid: UUID,
    val type: EntityType<*>,
    val position: Position,
    val yaw: Float,
    val pitch: Float,
    val headYaw: Float,
    /**
     * Velocity in blocks per tick
     */
    val velocity: Vector
) : OutgoingPacket()
