package space.uranos.net.packet.play

import space.uranos.net.packet.OutgoingPacket
import space.uranos.tag.Tag
import space.uranos.util.pluralizeWithCount

/**
 * Sent by the server while the player is joining.
 */
data class TagsPacket(val tags: Iterable<Tag>) : OutgoingPacket() {
    override fun toString(): String = "TagsPacket(${pluralizeWithCount("tag", tags.count())})"
}
