package space.uranos.logging

import ch.qos.logback.classic.Level
import ch.qos.logback.classic.spi.ILoggingEvent
import ch.qos.logback.core.AppenderBase
import space.uranos.Uranos

class LogbackAppender : AppenderBase<ILoggingEvent>() {
    override fun append(event: ILoggingEvent) {
        try {
            Uranos.loggingOutputProvider.log(
                true,
                event.loggerName,
                when (event.level) {
                    Level.TRACE -> Logger.Level.TRACE
                    Level.DEBUG -> Logger.Level.DEBUG
                    Level.INFO -> Logger.Level.INFO
                    Level.WARN -> Logger.Level.WARN
                    Level.ERROR -> Logger.Level.ERROR
                    else -> error("Should never happen")
                },
                event.message
            )
        } catch(e: Throwable) {}
    }
}
