package space.uranos.net.packet.login

import kotlinx.coroutines.launch
import space.uranos.net.PacketReceivedEventHandler
import space.uranos.net.UranosSession

object EncryptionResponsePacketHandler : PacketReceivedEventHandler<EncryptionResponsePacket>() {
    override suspend fun handle(session: UranosSession, packet: EncryptionResponsePacket) {
        try {
            session.scope.launch { session.joinProcedure.onEncryptionResponse(packet) }
        } catch (e: IllegalStateException) {
            session.failAndDisconnectBecauseOfClient("Client sent EncryptionResponsePacket when it was not allowed.")
        }
    }
}
