package space.uranos.net.packet.login

import kotlinx.coroutines.launch
import space.uranos.net.PacketReceivedEventHandler
import space.uranos.net.UranosSession

object LoginStartPacketHandler : PacketReceivedEventHandler<LoginStartPacket>() {
    override suspend fun handle(session: UranosSession, packet: LoginStartPacket) {
        try {
            session.scope.launch { session.joinProcedure.start(packet) }
        } catch (e: IllegalStateException) {
            session.failAndDisconnectBecauseOfClient("Client sent LoginStartPacket when it was not allowed")
        }
    }
}
