package space.uranos.net.packet.play

import space.uranos.chat.TextComponent
import space.uranos.net.PacketReceivedEventHandler
import space.uranos.net.UranosSession

object IncomingKeepAlivePacketHandler : PacketReceivedEventHandler<IncomingKeepAlivePacket>() {
    override suspend fun handle(session: UranosSession, packet: IncomingKeepAlivePacket) {
        val ping = (System.currentTimeMillis() - packet.id).toInt()

        if (ping >= session.server.config.timeout.toMillis()) session.disconnect(TextComponent of "Timed out")
        else session.ping = ping
    }
}
