package space.uranos.net.packet.play

import space.uranos.net.PacketReceivedEventHandler
import space.uranos.net.UranosSession

object IncomingPlayerPositionPacketHandler : PacketReceivedEventHandler<IncomingPlayerPositionPacket>() {
    override suspend fun handle(session: UranosSession, packet: IncomingPlayerPositionPacket) {
        session.earlyPlayer?.let {
            it.entity.position = packet.position
            it.entity.headYaw = packet.yaw
            it.entity.headPitch = packet.pitch
        } ?: error("Player not yet initialized")
    }
}
