package space.uranos.net.packet.play

import space.uranos.net.PacketReceivedEventHandler
import space.uranos.net.UranosSession

object PlayerLocationPacketHandler : PacketReceivedEventHandler<PlayerPositionPacket>() {
    override suspend fun handle(session: UranosSession, packet: PlayerPositionPacket) {
        val player = session.earlyPlayer ?: error("Player not yet initialized")
        player.entity.position = player.entity.position.copy(
            x = packet.position.x,
            y = packet.position.y,
            z = packet.position.z
        )
    }
}
